package cn.iocoder.yudao.module.pms.service.iotrddailyreportitem;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotrddailyreportitem.vo.IotRdDailyReportItemPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotrddailyreportitem.vo.IotRdDailyReportItemSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotrddailyreportitem.IotRdDailyReportItemDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotrddailyreportitem.IotRdDailyReportItemMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_RD_DAILY_REPORT_ITEM_NOT_EXISTS;

/**
 * 瑞都日报 (工作量)明细 Service 实现类
 *
 * @author ruiqi
 */
@Service
@Validated
public class IotRdDailyReportItemServiceImpl implements IotRdDailyReportItemService {

    @Resource
    private IotRdDailyReportItemMapper iotRdDailyReportItemMapper;

    @Override
    public Long createIotRdDailyReportItem(IotRdDailyReportItemSaveReqVO createReqVO) {
        // 插入
        IotRdDailyReportItemDO iotRdDailyReportItem = BeanUtils.toBean(createReqVO, IotRdDailyReportItemDO.class);
        iotRdDailyReportItemMapper.insert(iotRdDailyReportItem);
        // 返回
        return iotRdDailyReportItem.getId();
    }

    @Override
    public void updateIotRdDailyReportItem(IotRdDailyReportItemSaveReqVO updateReqVO) {
        // 校验存在
        validateIotRdDailyReportItemExists(updateReqVO.getId());
        // 更新
        IotRdDailyReportItemDO updateObj = BeanUtils.toBean(updateReqVO, IotRdDailyReportItemDO.class);
        iotRdDailyReportItemMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotRdDailyReportItem(Long id) {
        // 校验存在
        validateIotRdDailyReportItemExists(id);
        // 删除
        iotRdDailyReportItemMapper.deleteById(id);
    }

    private void validateIotRdDailyReportItemExists(Long id) {
        if (iotRdDailyReportItemMapper.selectById(id) == null) {
            throw exception(IOT_RD_DAILY_REPORT_ITEM_NOT_EXISTS);
        }
    }

    @Override
    public IotRdDailyReportItemDO getIotRdDailyReportItem(Long id) {
        return iotRdDailyReportItemMapper.selectById(id);
    }

    @Override
    public PageResult<IotRdDailyReportItemDO> getIotRdDailyReportItemPage(IotRdDailyReportItemPageReqVO pageReqVO) {
        return iotRdDailyReportItemMapper.selectPage(pageReqVO);
    }

}